///////////////////////////////////////////////////////////////////////////////
//
//  Filename: form1.h
//  Author: Wang, Yi
//  Last modified: 2004-2-25 3:55
//
///////////////////////////////////////////////////////////////////////////////

#ifndef FORM1_H
#define FORM1_H

#include "BahnDesign.h"
#include "CoordTrans.h"
#include "Track.h"

#include <qvariant.h>
#include <qmainwindow.h>
#include <qapplication.h>
#include <qframe.h>
#include <qvariant.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qstatusbar.h>
#include <qstring.h> 
#include <qpainter.h> 
#include <qfiledialog.h> 
#include <qdom.h>
#include <qmessagebox.h> 


/********************  Global  ************************************************/

enum BTool{BT_Normal, BT_NormalId, BT_Add, BT_Delete, BT_DeleteId, BT_Move, BT_MoveId, 
		BT_Moving, BT_RotateId, BT_Rotating, V_Move1, V_Move2};

/********************  Class ViewerWidget  ************************************/

class ViewerWidget : public QWidget
{
    Q_OBJECT
public:
	QStatusBar * pSBar;
    ViewerWidget(QWidget *parent=0, const char *name=0);
    void SelBahnDesignPt(int id);
	void drawBahnDesignPt(int id, bool IsNotClear);
	void _drawVect(int id, tagVect &vect, QColor &tColor);
    void paintEvent( QPaintEvent *e);
	void resizeEvent( QResizeEvent *e);
    void mousePressEvent( QMouseEvent *e);
    void mouseReleaseEvent( QMouseEvent *e);
    void mouseMoveEvent( QMouseEvent *e);
	void wheelEvent ( QWheelEvent *e );
private:
	QPainter *pPainter;
    void drawBahnDesign();
    void drawBahnStrecken();
	void drawTrack();
    void moveBahnDesignPt(double tx, double ty);
    void rotateBahnDesignPt(double tx, double ty);
};

/********************  Class SpeedWidget  ************************************/

class SpeedWidget : public QWidget
{
    Q_OBJECT
public:
    SpeedWidget(QWidget *parent=0, const char *name=0);
    void paintEvent( QPaintEvent * e);
//	void resizeEvent( QResizeEvent *);
private:
};

/**********************  Class Form1  *****************************************/

class Form1 : public QMainWindow
{
    Q_OBJECT

public:
    Form1( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~Form1();
    void SetCurTool(BTool);
    void ShowBDPtData(int id);
    void SaveBDPtData();
	void ShowCurStatus();
	void SavePara();
	void ShowPara();

    QFrame* frame4;
    ViewerWidget* Viewer;
    SpeedWidget* SpeedViewer;
    QTabWidget* tabWidget2;
	// tabPlan
    QWidget* tabPlan;
    QLabel* lbId;
    QLabel* lbTime;
    QLabel* lbX;
    QLabel* lbY;
    QLabel* lbAlpha;
    QLabel* lbSpeed;
    QLineEdit* leId;
    QLineEdit* leTime;
    QLineEdit* leX;
    QPushButton* btOK;
    QLineEdit* leY;
    QLineEdit* leSpeed;
    QLineEdit* leAlpha;
	// tabPara
    QWidget* tabPara;
    QLabel* lbMinR;
    QLineEdit* leMinR;
    QLabel* lbMaxR;
    QLineEdit* leMaxR;
    QLabel* lbPlusA;
    QLineEdit* lePlusA;
    QLabel* lbNegA;
    QLineEdit* leNegA;
    QLabel* lbMaxSpeed;
    QLineEdit* leMaxSpeed;
    QLabel* lbSpeedFact;
    QLineEdit* leSpeedFact;
    QLabel* lbLenkFact;
    QLineEdit* leLenkFact;
    QLabel* lbMinSpeedHold;
    QLineEdit* leMinSpeedHold;
    QPushButton* btOK_2;
    
    QMenuBar *Menubar;
    QPopupMenu *mFile;
    QPopupMenu *mBahn;
    QPopupMenu *mView;
    QAction* mAdd;
    QAction* mDelete;
    QAction* mMove;
    QAction* mClear;
	QAction* mSavePlan;
	QAction* mLoadPlan;
    QAction* fileExportAction;
    QAction* fileImportAction;
    QAction* mVMove;
    QAction* mZoomIn;
    QAction* mZoomOut;

public slots:
	virtual void mSavePlanClick();
	virtual void mLoadPlanClick();
	virtual void fileExportClick();
	virtual void fileImportClick();
    virtual void mAddClick();
    virtual void mDeleteClick();
    virtual void mMoveClick();
    virtual void mClearClick();
    virtual void mZoomInClick();
    virtual void mZoomOutClick();
    virtual void mVMoveClick();
    virtual void btOK_clicked();
    virtual void btOK_2_clicked();

protected:
    QHBoxLayout* Form1Layout;
    QVBoxLayout* frame4Layout;

protected slots:
    virtual void languageChange();
};

#endif // FORM1_H
